#!/bin/sh

#todo: logout

CWD=$(dirname $0)

source $CWD/../router.conf

ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
USER="admin"
NEW_CHANNEL=$1
NEW_CHANWIDTH=$2

check_arguments(){
    if [ "$NEW_CHANWIDTH" = "20" ]; then
        kanalbreite=1
    elif [ "$NEW_CHANWIDTH" = "40" ]; then
        kanalbreite=2
    fi
}

get_token(){
    token_resp=$(curl -s \
	-H "Host: $ROUTER_IP" \
	-H "Accept: application/xml, text/xml, */*" \
	-H "Accept-Language: en-US,en;q=0.5" \
	-H "Accept-Encoding: gzip, deflate" \
	-H "Referer: http://$ROUTER_IP/login.html" \
	-H "X-Requested-With: XMLHttpRequest" \
	-H "DNT: 1" \
	-H "Connection: keep-alive" \
	-H "Cookie: prefIdiom=images/de.gif*German*de" \
	-H "Content-Length: 0" \
	"http://$ROUTER_IP/xml/GlobalSettings.xml")
    token=$(echo $token_resp | awk -F'<Token>' '{print $2}' | awk -F'</Token>' '{print $1}')
    #echo "Token: $token"
}

login(){
	get_token
	data="token=$token&password=$PASSWORD&user=$USER"
	login_resp=$(curl -s \
		-H "Host: $ROUTER_IP" \
		-H "Accept: text/plain, */*" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/login.html" \
		-H "Content-Type: application/x-www-form-urlencoded" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de" \
		-d "$data" \
		"http://$ROUTER_IP/login/Login.txt")
	#echo "Login response: $login_resp"
}

get_wifiInfo(){
	wifiInfo_resp=$(curl -s \
		-H "Host: $ROUTER_IP" \
		-H "Accept: application/xml, text/xml, */*" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/wirelessBasic.html" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "Content-Type: text/plain;charset=UTF-8" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de" \
		"http://$ROUTER_IP/xml/CmgwWirelessBasic.xml")
	SSID=$(echo $wifiInfo_resp | awk -F'<wlSsid>' '{print $2}' | awk -F'</wlSsid>' '{print $1}')
	kontroll_seitenband=$(echo $wifiInfo_resp | awk -F'<wlNCtrlsb>' '{print $2}' | awk -F'</wlNCtrlsb>' '{print $1}')
	kanalbreite=$(echo $wifiInfo_resp | awk -F'<wlNBwCap>' '{print $2}' | awk -F'</wlNBwCap>' '{print $1}')
	if [ $kanalbreite -eq 1 ]; then
		kontroll_seitenband=1
	fi
	wmm=$(echo $wifiInfo_resp | awk -F'<wlWMM>' '{print $2}' | awk -F'</wlWMM>' '{print $1}')
	netzwerk_ausblenden=$(echo $wifiInfo_resp | awk -F'<wlHide>' '{print $2}' | awk -F'</wlHide>' '{print $1}')
	wlMaxStation=$(echo $wifiInfo_resp | awk -F'<wlMaxStation>' '{print $2}' | awk -F'</wlMaxStation>' '{print $1}')
	uebertragungsmodus=$(echo $wifiInfo_resp | awk -F'<wlTxMode>' '{print $2}' | awk -F'</wlTxMode>' '{print $1}')
	wlChannel=$(echo $wifiInfo_resp | awk -F'<wlChannel>' '{print $2}' | awk -F'</wlChannel>' '{print $1}')
	#wlChannelSettings=$(echo $wifiInfo_resp | awk -F'<wlChannelSetting>' '{print $2}' | awk -F'</wlChannelSetting>' '{print $1}')
	#echo "SSID: $SSID"
	#echo "Kontrollseitenband: $kontroll_seitenband"
	#echo "Kanalbreite: $kanalbreite"
	#echo "WMM: $wmm"
	#echo "Netzwerk ausblenden: $netzwerk_ausblenden"
	#echo "Max. Anzahl WLAN Stationen: $wlMaxStation"
	#echo "Ubertragungsmodus: $uebertragungsmodus"
	#echo "WiFi Channel: $wlChannel"
	#echo "WiFi Channel Settings: $wlChannelSettings"
}

change_channel(){
	get_wifiInfo
        check_arguments
	get_token
	#kontroll_seitenband=2 # 1: Oberes Kontrollseitenband, 2: Unteres Kontrollseitenband
	#kanalbreite=2 # 1: 20MHz, 2: 20/40MHz
	#wmm=1 #1: WMM an, 2: WMM aus
	#netzwerk_ausblenden=2 # 2: nicht ausblenden, 1: ausblenden
	#wlMaxStation=0
	#uebertragungsmodus=10
	# Uebertragungsmodis:
	# -------------------
        # 1: 802.11b einzeln (Kanalbreite undefiniert hier!)
	# 2: 802.11g einzeln (Kanalbreite undefiniert hier!)
	# 3: 802.11b/g gemischt (Kanalbreite undefiniert hier!)
	# 8: 802.11n einzeln
	# 10: 802.11g/n gemischt
	# 11: 802.11b/g/n gemischt
	if [ -z "$wlChannel" ]; then
		echo "WiFi is disabled. Please enable WiFi."
		exit 1
	fi
	data="token=${token}&wlEnbl=1&wlSsid1=${SSID}&wlSsid2=undefined&wlSsid3=undefined&wlSsid4=undefined&wlAttr1=${netzwerk_ausblenden}%3B1%3B${wmm}%3B2%3B&wlAttr2=undefined%3Bundefined%3Bundefined%3Bundefined%3B&wlAttr3=undefined%3Bundefined%3Bundefined%3Bundefined%3B&wlAttr4=undefined%3Bundefined%3Bundefined%3Bundefined%3B&wlNBwCap=${kanalbreite}&wlNCtrlsb=${kontroll_seitenband}&wlChannelSetting=${NEW_CHANNEL}&wlMCastRate=1&wlBandMode=1&wlTxMode=${uebertragungsmodus}%3Bundefined%3Bundefined%3Bundefined%3B&wlTxRate=0%3Bundefined%3Bundefined%3Bundefined%3B&wlMaxStation=${wlMaxStation}%3Bundefined%3Bundefined%3Bundefined%3B&wlNCtrlAclEnable=0&wlAcllistInfo=0"
	changeChannel_resp=$(curl -s \
		-H "Host: $ROUTER_IP" \
		-H "Accept: */*" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/wirelessBasic.html" \
		-H "Content-Type: application/x-www-form-urlencoded" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de" \
		-H "Pragma: no-cache" \
		-H "Cache-Control: no-cache" \
		-d "$data" \
		"http://$ROUTER_IP/setWirelessBasic.html")
	sleep 15
}

check_if_channel_changed(){
    new_kanalbreite=$kanalbreite
    get_wifiInfo
    if [ "$wlChannel" = "$NEW_CHANNEL" ]; then
    	echo "Sucessfully apply new wifi channel $NEW_CHANNEL"
    else
    	echo "Apply new channel $NEW_CHANNEL failed."
    fi
    if [ -z "$SSID" ]; then
    	echo "WARNING: No AP SSID defined!"
    fi
    #echo "NEW CHANWIDTH: $NEW_CHANWIDTH"
    #echo "kanalbreite: $kanalbreite"
    #echo "new_kanalbreite: $new_kanalbreite"
    if [ -n "$NEW_CHANWIDTH" ] && [ "$kanalbreite" = "$new_kanalbreite" ]; then
        echo "Sucessfully apply new wifi channel bandwidth ${NEW_CHANWIDTH} MHz"
    elif [ -n "$NEW_CHANWIDTH" ]; then
        echo "Apply new channel bandwidth failed."
    fi
}

logout(){
	logout_resp=$(curl -s \
		-H "Host: $ROUTER_IP" \
		-H "Accept: text/plain, */*" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://$ROUTER_IP/wirelessBasic.html" \
		-H "X-Requested-With: XMLHttpRequest" \
		-H "DNT: 1" \
		-H "Connection: keep-alive" \
		-H "Cookie: prefIdiom=images/de.gif*German*de" \
		-H "Content-Length: 0" \
		"http://$ROUTER_IP/login/Logout.txt")
}

main(){
	login
	change_channel
	check_if_channel_changed
	logout
}

main
