#!/bin/sh

NEW_CHANNEL=$1

CWD=$(dirname $0)
ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
source $CWD/../router.conf

URL_PREFIX="http://$ROUTER_IP/main.cgi"


get_cookies(){
	url="$URL_PREFIX?page=login.html"
	DM_COOKIE=$(curl -s -m 5 -c $CWD/cookie.txt $url | grep dm_cookie | awk -F"dm_cookie='" '{print $2}' | awk -F"'" '{print $1}')
	WBM_COOKIE_SESSION=$(cat $CWD/cookie.txt | grep wbm_cookie_session_id | awk '{print $7}')
	cat $CWD/cookie.txt | sed "s/${ROUTER_IP}//g" | sed "s:\t\/\t:\t\t:g " > $CWD/cookie2.txt
}


get_auth_key(){
	url="$URL_PREFIX?js=rg_config.js"
	curl -s -m 5 -b $CWD/cookie.txt -o $CWD/config.js $url > /dev/null
	AUTH_KEY=$(cat $CWD/config.js | grep auth_key | grep -oE "[0-9]+")
}


encrypt_md5_password(){
	PASSWORD_MD5=$(echo -n "$PASSWORD$AUTH_KEY" | md5sum | awk '{print $1}')
}


login(){
        url="http://$ROUTER_IP/data_model.cgi"
        get_cookies
        get_auth_key
        encrypt_md5_password
        echo -e "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\"><soapenv:Header><DMCookie>${DM_COOKIE}</DMCookie></soapenv:Header><soapenv:Body><cwmp:Login xmlns=\"\"><ParameterList><Username>vodafone</Username><Password>${PASSWORD_MD5}</Password><AllowRelogin>0</AllowRelogin></ParameterList></cwmp:Login></soapenv:Body></soapenv:Envelope>" > $CWD/step1_soap_data.xml
        curl "http://${ROUTER_IP}/data_model.cgi" \
        	-s \
        	-H "Host: ${ROUTER_IP}" \
        	-H "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0" \
        	-H "Accept: application/xml, text/xml, */*; q=0.01" \
        	-H "Accept-Language: de,en-US;q=0.7,en;q=0.3" \
        	-H "Accept-Encoding: gzip, deflate" \
        	-H "Referer: http://${ROUTER_IP}/main.cgi?page=login.html" \
        	-H "Content-Type: text/xml; charset=UTF-8" \
        	-H "Method: POST" \
        	-H "SOAPServer: " \
        	-H "SOAPAction: cwmp:Login" \
        	-H "X-Requested-With: XMLHttpRequest" \
        	-H "Content-Length: 387" \
        	-H "DNT: 1" \
        	-H "Connection: keep-alive" \
        	-H "Cookie: wbm_cookie_session_id=${WBM_COOKIE_SESSION}" \
        	-d  @$CWD/step1_soap_data.xml \
        	-o $CWD/step2_answer.html \
        	-c "$CWD/step2_cookies.txt" \
        	-b "$CWD/cookie2.txt"
        curl -s "$URL_PREFIX/main.cgi?page=app.html" -b $CWD/step2_cookies.txt -o $CWD/step3_answer.html
        WBM_COOKIE_SESSION2=$(cat $CWD/step2_cookies.txt | grep "wbm_cookie_session_id" | awk '{print $7}')
        DM_COOKIE2=$(cat $CWD/step3_answer.html | grep dm_cookie | awk -F"dm_cookie='" '{print $2}' | awk -F"'" '{print $1}')
}

change_channel(){
	echo -n "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\"><soapenv:Header><DMCookie>${DM_COOKIE2}</DMCookie></soapenv:Header><soapenv:Body><cwmp:SetParameterValues xmlns=\"\"><ParameterList><ParameterValueStruct><Name>InternetGatewayDevice.LANDevice.1.WLANConfiguration.2.Channel</Name><Value>${NEW_CHANNEL}</Value></ParameterValueStruct></ParameterList></cwmp:SetParameterValues></soapenv:Body></soapenv:Envelope>" > $CWD/step4_soap_data.xml
	curl_output=$(curl "http://${ROUTER_IP}/data_model.cgi" \
		-s \
		-H "Host: ${ROUTER_IP}" \
		-H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
		-H "Accept: application/xml, text/xml, */*; q=0.01" \
		-H "Accept-Language: en-US,en;q=0.5" \
		-H "Accept-Encoding: gzip, deflate" \
		-H "Referer: http://${ROUTER_IP}/main.cgi?page=app.html" \
		-H "Content-Type: text/xml; charset=UTF-8" \
	        -H "Method: POST" \
	        -H "SOAPServer: " \
	        -H "SOAPAction: cwmp:SetParameterValues" \
	        -H "X-Requested-With: XMLHttpRequest" \
	        -H "DNT: 1" \
	        -H "Connection: keep-alive" \
	        -H "Cookie: wbm_cookie_session_id=${WBM_COOKIE_SESSION2}; basic_expert_mode=Expert; globalMessages={}" \
		--data @"$CWD/step4_soap_data.xml")
	#echo $curl_output
}

login
change_channel

rm $CWD/config.js
rm $CWD/cookie.txt
rm $CWD/cookie2.txt
rm $CWD/step1_soap_data.xml
rm $CWD/step2_answer.html
rm $CWD/step2_cookies.txt
rm $CWD/step3_answer.html
rm $CWD/step4_soap_data.xml
