#!/bin/sh

CWD=$(dirname $0)
ROUTER_IP=$(/bin/sh "$CWD/get_router_ip.sh")

URL_PREFIX="http://${ROUTER_IP}"
login_page=$(curl -Ls "${URL_PREFIX}")

# If noscript-page is available, then navigate there.
noscript=$(echo ${login_page} | grep "<noscript>")
if [ -n "$noscript" ]; then
    noscript_urlsuffix=$(echo $noscript | awk -F'url=' '{print $2}' | awk -F'"' '{print $1}')
    login_page=$(curl -sL "$URL_PREFIX/$noscript_urlsuffix")
fi

# Which vendor keyword is present on the login page
if [ -n "$(echo $login_page | grep EasyBox)" ]; then
    echo "easybox"
elif [ -n "$(echo $login_page | grep Speedport)" ]; then
    echo "speedport"
elif [ -n "$(echo $login_page | grep -F 'FRITZ!Box')" ]; then
    echo "avm"
elif [ -n "$(echo $login_page | grep -F 'Turris')" ]; then
    echo "turris"
fi
