#!/bin/sh

###
### ROUTER VENDOR IDENTIFICATION SCRIPT 
###

CWD=$(dirname $0)
source $CWD/router.conf
ROUTER_IP=$(sh "$CWD/general/get_router_ip.sh")

while getopts p:udc: opt
do
	case $opt in
		p) PASSWORD=$OPTARG;;
		d) OPTION="-d";;
		u) OPTION="-u";;
		c) OPTION="-c"
			NEW_CHANNEL=$OPTARG;;
	esac
done

URL_PREFIX="http://${ROUTER_IP}"

login_page=$(curl -Ls "${URL_PREFIX}")

# If noscript-page is available, then navigate there.
noscript=$(echo ${login_page} | grep "<noscript>")
if [ -n "$noscript" ]; then
	noscript_urlsuffix=$(echo $noscript | awk -F'url=' '{print $2}' | awk -F'"' '{print $1}')
	login_page=$(curl -sL "$URL_PREFIX/$noscript_urlsuffix")
fi

# Which vendor keyword is present on the login page
if [ -n "$(echo $login_page | grep EasyBox)" ]; then
	#echo "Hi, I am an EasyBox!"
	sh $CWD/easybox/eb_get_block_stats.sh -r $ROUTER_IP -p $PASSWORD $OPTION
elif [ -n "$(echo $login_page | grep Speedport)" ]; then
	#echo "Hi, I am a Speedport!"
	MODEL=$(sh $CWD/speedport/sp_identify_model.sh -m)
        echo $MODEL
	if [ "$MODEL" = "Speedport Smart" ]; then
		#echo "I am a Speedport Smart!"
		sh $CWD/speedport/sp_smart.sh -r $ROUTER_IP -p $PASSWORD $OPTION
	elif [ "$MODEL" = "Speedport W 724V" ]; then
		#echo "I am a Speedport W 724V!"
		sh $CWD/speedport/sp_w724v_A.sh -r $ROUTER_IP -p $PASSWORD $OPTION
	fi
elif [ -n "$(echo $login_page | grep -F 'FRITZ!Box')" ]; then
	#echo "Hi, I am a Fritz!Box!"
  	/bin/sh $CWD/fritzbox/fb_wan_stats.sh -r $ROUTER_IP $OPTION
fi
