#!/bin/ash

###Tested router with following firmware versions:
###Compal CH7466CE  - 4.50.19.12
###Compal CH6640E   - CH6640-4.5.0.5-NOSH

CWD=$(dirname $0)
ROUTER_IP=$(ash "$CWD/get_router_ip.sh")
PASSWORD="PASSWORD"
URL_PREFIX="http://$ROUTER_IP"
login_page=$(curl -Ls "$URL_PREFIX")

get_token(){
	token=$(cat cookie.txt | grep sessionToken | awk '{print $7}')
	rm cookie.txt
}

# If noscript-page is avaiable, then navigate there.
noscript=$(echo ${login_page} | grep "<noscript>")
if [ -n "$noscript" ]
then
    noscript_urlsuffix=$(echo $noscript | \
        awk -F'url=' '{print $2}' | \
        awk -F'"' '{print $1}')
    login_page=$(curl -sL "$URL_PREFIX/$noscript_urlsuffix")
fi

# Which vendor keyword is present on the login page.
if [ -n "$(echo $login_page | grep Turris)" ]
then
    echo Turris > router.txt
elif [ -n "$(echo $login_page | grep EasyBox)" ]
then
    echo Easybox > router.txt
elif [ -n "$(echo $login_page | grep -F 'FRITZ!Box')" ]
then
    #echo Fritzbox
    KEY="j:Name"
    xml_out=$(curl -s "http://${ROUTER_IP}/jason_boxinfo.xml")
    echo $(echo $xml_out | \
        awk -F"<$KEY>" '{print $2}' | \
        awk -F"<" '{print $1}') > router.txt
else
    curl -s \
    	-H "Host: $ROUTER_IP" \
    	-H "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8" \
    	-H "Accept-Language: en-US,en;q=0.5" \
    	-H "Accept-Encoding: gzip, deflate" \
    	-H "DNT: 1" \
    	-H "Connection: keep-alive" \
    	-H "Upgrade-Insecure-Requests: 1" \
    	-c "cookie.txt" \
    	"http://$ROUTER_IP/" > /dev/null
    get_token
    if [ -n "$token" ]
    then
        curl -s \
            -H "Host: $ROUTER_IP" \
            -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
            -H "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8" \
            -H "Accept-Language: en-US,en;q=0.5" \
            -H "Accept-Encoding: gzip, deflate" \
            -H "DNT: 1" \
            -H "Connection: keep-alive" \
            -H "Upgrade-Insecure-Requests: 1" \
            -H "If-Modified-Since: Thu, 30 Mar 2017 10:30:30 GMT" \
            -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
            -c "cookie.txt" \
            "http://$ROUTER_IP/common_page/login.html" > login_page.txt
        login_page=$(cat login_page.txt)
        rm login_page.txt
        get_token
        if [ -n "$(echo $login_page | grep 'Compal Broadband Networks')" ]
        then
	    login_data="token=$token&fun=15&Username=admin&Password=$PASSWORD"
	    login_resp=$(curl -s \
	    	-H "Host: $ROUTER_IP" \
	    	-H "Accept: text/plain, */*; q=0.01" \
	    	-H "Accept-Language: en-US,en;q=0.5" \
	    	-H "Accept-Encoding: gzip, deflate" \
	    	-H "Referer: http://$ROUTER_IP/common_page/login.html" \
	    	-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
	    	-H "X-Requested-With: XMLHttpRequest" \
	    	-H "DNT: 1" \
	    	-H "Connection: keep-alive" \
	    	-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
	    	-c "cookie.txt" \
	    	-d "$login_data" \
	    	"http://$ROUTER_IP/xml/setter.xml") > /dev/null
	    get_token
            if [ "$login_resp" = "successful" ]
            then
                data="token=$token&fun=1"
                get_resp=$(curl -s \
                	-H "Host: $ROUTER_IP" \
                	-H "Accept: application/xml, text/xml, */*; q=0.01" \
                	-H "Accept-Language: en-US,en;q=0.5" \
                	-H "Accept-Encoding: gzip, deflate" \
                	-H "Referer: http://$ROUTER_IP/wifi_page/wlanRadio.html" \
                	-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
                	-H "X-Requested-With: XMLHttpRequest" \
                	-H "DNT: 1" \
                	-H "Connection: keep-alive" \
                	-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
                	-c "cookie.txt" \
                	-d "$data" \
                        "http://$ROUTER_IP/xml/getter.xml")
                MODEL=$(echo $get_resp | \
                    awk -F'<SwVersion>' '{print $2}'| \
                    awk -F'-' '{print $1}')
                if [ -n "$MODEL" ]
                then
                    echo "Compal $MODEL" > router.txt
                else
                    echo "Router model is not supported."
                    exit 1
                fi
                # Logout
                get_token
                data="token=$token&fun=1"
                curl -s \
                    -H "Host: $ROUTER_IP" \
                    -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
                    -H "Accept: application/xml, text/xml, */*; q=0.01" \
                    -H "Accept-Language: en-US,en;q=0.5" \
                    -H "Accept-Encoding: gzip, deflate" \
                    -H "Referer: http://$ROUTER_IP/index.html" \
                    -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
                    -H "X-Requested-With: XMLHttpRequest" \
                    -H "DNT: 1" \
                    -H "Connection: keep-alive" \
                    -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
                    -c "cookie.txt" \
                    -d "$data" \
                    "http://$ROUTER_IP/xml/getter.xml" > /dev/null
                get_token
                data="token=$token&fun=16"
                curl -s \
                    -H "Host: $ROUTER_IP" \
                    -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
                    -H "Accept: text/plain, */*; q=0.01" \
                    -H "Accept-Language: en-US,en;q=0.5" \
                    -H "Accept-Encoding: gzip, deflate" \
                    -H "Referer: http://$ROUTER_IP/index.html" \
                    -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
                    -H "X-Requested-With: XMLHttpRequest" \
                    -H "DNT: 1" \
                    -H "Connection: keep-alive" \
                    -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
                    -d "$data" \
                    -c "cookie.txt" \
                    "http://$ROUTER_IP/xml/setter.xml" > /dev/null
                get_token
            else
                echo "Given router password is incorrect."
                exit 1
            fi
        else
            echo "Router model is no supported."
            exit 1
        fi
    else
        curl_output=$(curl -s \
            -H "Host: $ROUTER_IP" \
            -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
            -H "Accept: application/xml, text/xml, */*" \
            -H "Accept-Language: en-US,en;q=0.5" \
            -H "Accept-Encoding: gzip, deflate" \
            -H "Referer: http://$ROUTER_IP/" \
            -H "X-Requested-With: XMLHttpRequest" \
            -H "DNT: 1" \
            -H "Connection: keep-alive" \
            "http://$ROUTER_IP/xml/GlobalSettings.xml")
        MODEL=$(echo $curl_output | \
            awk -F'<PlatformType>' '{print $2}' | \
            awk -F'<' '{print $1}')
        if [ -n "$MODEL" ]
        then
            echo "Compal $MODEL" > router.txt
        else
            echo "Router model is not supported or wrong gateway router IP address."
            exit 1
        fi
    fi
fi
